
#include "pcre.bi"

const MOVE_PATTERN = "[a-h][1-8][a-h][1-8][nbrq]*"
const FEN_RECORD_PATTERN = _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & "/" & _
  "[1-8BKNPQRbknpqr]+" & _
  "\s" & "[wb]" & _
  "\s" & "([KQkq]+|\-)" & _
  "\s" & "([a-h][36]|\-)" & _
  "\s" & "\d+" & _
  "\s" & "[1-9]\d*"

/'
declare function ExtractStrings(byval aPattern as string, byval aBuffer as string, aArray() as string, aPreserve as integer = 0) as integer

const SAMPLE = "position fen rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1 moves e2e4 e7e5 d2d4 d7d5"

dim a() as string

if ExtractStrings(FEN_RECORD_PATTERN, SAMPLE, a()) = ubound(a) - lbound(a) + 1 then
  for i as integer = lbound(a) to ubound(a)
    print(a(i))
  next i
end if

if ExtractStrings(MOVE_PATTERN, SAMPLE, a()) = ubound(a) - lbound(a) + 1 then
  for i as integer = lbound(a) to ubound(a)
    print(a(i))
  next i
end if

sleep
'/

function ExtractStrings(byval aPattern as string, byval aBuffer as string, aArray() as string, aPreserve as integer = 0) as integer
  const OVECCOUNT = 300
  dim as zstring ptr error_
  dim as integer error_offset
  dim as integer rc, i
  dim as integer ovector(OVECCOUNT - 1)
  dim as integer result
  dim as pcre ptr re
  
  if not aPreserve then
    erase aArray
  end if
  
  result = 0
  
  re = pcre_compile(aPattern, 0, @error_, @error_offset, NULL)
  if re = NULL then
    return result
  end if
  
  i = 0
  do
    rc = pcre_exec(re, NULL, strptr(aBuffer), len(aBuffer), i, 0, @ovector(0), OVECCOUNT)
    if rc > 0 then
      redim preserve aArray(lbound(aArray) to ubound(aArray) + 1)
      aArray(ubound(aArray)) = mid(aBuffer, ovector(0) + 1, ovector(1) - ovector(0))
      result += 1
      i = ovector(1)
    end if
  loop while rc >= 0

  return result
end function
