
#include "chess.bas"
#include "extract.bas"

print("RANDOM - Chess Engine by Roland Chastain")

randomize(timer)

dim game as chess.TGame

#ifdef DEBUG
ff = freefile()
open exepath & "\" & "log.txt" for output as #ff
#endif

game.Initialize()
game.GenerateLegalMoves()

dim as string s, ss()

do
  input(s)
  
  if s = "quit" then
    exit do
  
  elseif s = "uci" then
    print("id name RANDOM")
    print("id author Roland CHASTAIN")
    print("uciok")
  
  elseif s = "isready" then
    print("readyok")
  
  elseif s = "ucinewgame" then
    game.Initialize()
    game.GenerateLegalMoves()
  
  elseif instr(s, "position") then
#ifdef DEBUG
    AddToLog("[" & s & "]")
#endif
    if instr(s, "startpos") then
      game.Initialize()
    
    elseif instr(s, "fen") then
      ExtractStrings(FEN_RECORD_PATTERN, s, ss())
#ifdef DEBUG
      AddToLog("[" & ss(lbound(ss)) & "]")
#endif
      game.Initialize(ss(lbound(ss)))
    end if
    
    game.GenerateLegalMoves()
    
    if instr(s, "moves") then
      ExtractStrings(MOVE_PATTERN, s, ss())
      
      for i as integer = lbound(ss) to ubound(ss)
#ifdef DEBUG
        AddToLog("[" & str(i) & "][" & ss(i) & "]")
#endif
        if game.FindMove(ss(i)) then
          game.DoMove(ss(i))
          game.GenerateLegalMoves()
        else
#ifdef DEBUG
          AddToLog("illegal move [" & ss(i) & "]")
#endif
        end if
      next i
    end if
  
  elseif instr(s, "go") then
    print("bestmove " & game.RandomMove())
  else
#ifdef DEBUG
    AddToLog("unknown command [" & s & "]")
#endif
  end if
  
  sleep 10
loop

#ifdef DEBUG
close #ff
#endif
